// -*- C++ -*-
/*!
 * @file  OUTPUT_CHECK.cpp
 * @brief Data output sample check
 * @date $Date$
 *
 * $Id$
 */

#include "OUTPUT_CHECK.h"

// Module specification
// <rtc-template block="module_spec">
static const char* output_check_spec[] =
  {
    "implementation_id", "OUTPUT_CHECK",
    "type_name",         "OUTPUT_CHECK",
    "description",       "Data output sample check",
    "version",           "0.1",
    "vendor",            "Vstone",
    "category",          "Test",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "0",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
OUTPUT_CHECK::OUTPUT_CHECK(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_InUS1In("InUS1", m_InUS1),
    m_InUS2In("InUS2", m_InUS2),
    m_InBlIn("InBl", m_InBl)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
OUTPUT_CHECK::~OUTPUT_CHECK()
{
}



RTC::ReturnCode_t OUTPUT_CHECK::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("InUS1", m_InUS1In);
  addInPort("InUS2", m_InUS2In);
  addInPort("InBl", m_InBlIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t OUTPUT_CHECK::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_CHECK::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_CHECK::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_CHECK::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_CHECK::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t OUTPUT_CHECK::onExecute(RTC::UniqueId ec_id)
{
  //an1iTimedUShortj̓͂邩
  if (m_InUS1In.isNew()){
    //͂̂œǂݍŉʂɕ\
    m_InUS1In.read();
    std::cout << "An1 = " << m_InUS1.data << std::endl;
  }

  //an2iTimedUShortj̓͂邩
  if (m_InUS2In.isNew()){
    //͂̂œǂݍŉʂɕ\
    m_InUS2In.read();
    std::cout << "An2 = " << m_InUS2.data << std::endl;
  }

  //btniTimedBooleanj̓͂邩
  if (m_InBlIn.isNew()){
    //͂̂œǂݍŉʂɕ\
    m_InBlIn.read();
    std::cout << "Bl = " << m_InBl.data << std::endl;
  }

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t OUTPUT_CHECK::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_CHECK::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_CHECK::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_CHECK::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_CHECK::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void OUTPUT_CHECKInit(RTC::Manager* manager)
  {
    coil::Properties profile(output_check_spec);
    manager->registerFactory(profile,
                             RTC::Create<OUTPUT_CHECK>,
                             RTC::Delete<OUTPUT_CHECK>);
  }
  
};


